unit hiDateConvertor; {  - ver 1.00 }

interface

uses Windows,Kol,Share,Debug;

type
 THIDateConvertor = class(TDebug)
   private
      FResult:TData;
   public
     _prop_Mode:byte;
     _prop_Format:string;

     _data_Data:THI_Event;
     _event_OnResult:THI_Event;

     procedure _work_doConvert0(var _Data:TData; Index:word);//DateRealToMT
     procedure _work_doConvert1(var _Data:TData; Index:word);//MTToDateReal
     procedure _work_doConvert2(var _Data:TData; Index:word);//DateToStrFmt
     procedure _work_doConvert3(var _Data:TData; Index:word);//TimeToStrFmt
     procedure _work_doConvert4(var _Data:TData; Index:word);//StrToDateTimeFmt
     procedure _var_Result     (var _Data:TData; Index:word);

end;

implementation

procedure THIDateConvertor._work_doConvert0;
var   da,db,dc,dd,de,df,dg,dh,di:TData;
      _DayOfWeek:integer;
      _LeapYear:word;
      DateTime:TDateTime;
      ST:TSystemTime;
begin
   FillChar(ST, Sizeof(ST), 0);
   DateTime:= ReadReal(_Data,_data_Data,0);
   DateTime2SystemTime(DateTime, ST);
   _DayOfWeek:= DayOfWeek(DateTime);
   _LeapYear:= 0;
   if IsLeapYear(ST.wYear) then _LeapYear:= 1; 
   dtInteger(da,_LeapYear);
   dtInteger(db,_DayOfWeek);   
   da.ldata:= @db;
   dtInteger(dc,ST.wYear);
   db.ldata:= @dc;
   dtInteger(dd,ST.wMonth);
   dc.ldata:= @dd;
   dtInteger(de,ST.wDay);
   dd.ldata:= @de;
   dtInteger(df,ST.wHour);
   de.ldata:= @df;
   dtInteger(dg,ST.wMinute);
   df.ldata:= @dg;
   dtInteger(dh,ST.wSecond);
   dg.ldata:= @dh;
   dtInteger(di,ST.wMilliseconds);
   dh.ldata:= @di;
   CopyData(@FResult,@da);
   _hi_onEvent_(_event_onResult,FResult);
end;

procedure THIDateConvertor._work_doConvert1;
var   dt:TData;
      d:PData;
      DateTime:TDateTime;
      ST:TSystemTime;
begin
   dt:= ReadMTData(_Data,_data_Data);
   d:=@dt;
   FillChar(ST, Sizeof(ST), 0);
TRY
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wYear:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wMonth:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wDay:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wHour:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wMinute:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wSecond:= ToInteger(d^);
      d := d.ldata;
   end;
   if (d <> nil) and not _IsNULL(d^) then begin
      ST.wMilliseconds:= ToInteger(d^);
      d := d.ldata;
   end;
   SystemTime2DateTime(ST, DateTime);
   dtReal(dt,DateTime);
   CopyData(@FResult,@dt);
   _hi_onEvent_(_event_onResult,FResult);
FINALLY
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
END;
end;

procedure THIDateConvertor._work_doConvert2;
var   DateTime:TDateTime;
      FDateTime:string; 
      dt:TData;
begin
   DateTime:= ReadReal(_Data,_data_Data,0);
   FDateTime:= Date2StrFmt(_prop_Format, DateTime);
   dtString(dt,FDateTime);
   CopyData(@FResult,@dt);   
   _hi_CreateEvent(_Data,@_event_onResult, FResult);
end;

procedure THIDateConvertor._work_doConvert3;
var   DateTime:TDateTime;
      FDateTime:string; 
      dt:TData;
begin
   DateTime:= ReadReal(_Data,_data_Data,0);
   FDateTime:= Time2StrFmt(_prop_Format, DateTime);
   dtString(dt,FDateTime);
   CopyData(@FResult,@dt);   
   _hi_CreateEvent(_Data,@_event_onResult, FResult);
end;

procedure THIDateConvertor._work_doConvert4;
var   DateTime:TDateTime;
      FDateTime:string; 
      dt:TData;
begin
   FDateTime:= ReadString(_Data,_data_Data,'');
   DateTime:= Str2DateTimeFmt(_prop_Format, FDateTime);
   dtReal(dt,DateTime);
   CopyData(@FResult,@dt);   
   _hi_CreateEvent(_Data,@_event_onResult, FResult);   
end;

procedure THIDateConvertor._var_Result;
begin
   CopyData(@_Data,@FResult); 
end;

end.
